/* This file is part of X2C. http://www.mechatronic-simulation.org/                                                   */

/* Model: DemoApplication                                                                                             */
/* Date:  2018-03-19 12:45                                                                                            */

/* X2C-Version: 1405                                                                                                  */

/* Mask Parameter includes (Conversion-on-Target blocks)                                                              */
/* Common includes                                                                                                    */
#include "TableStruct.h"
/* Generated file includes                                                                                            */
#include "FlashTable.h"
#include "RamTable.h"
#include "X2C.h"

/**********************************************************************************************************************/
/**                                                       Model                                                      **/
/**********************************************************************************************************************/
struct x2cModel x2cModel;

/**********************************************************************************************************************/
/**                                                       Scope                                                      **/
/**********************************************************************************************************************/
SCOPE_MAIN x2cScope;


/* Mask Parameter variables                                                                                           */

/* Block function table                                                                                               */
#define END_BLOCKFUNCTIONS { (uint16)0, (void (*)(void*))0, (void (*)(void*))0, \
    (tLoadImplementationParameter)0, (tSaveImplementationParameter)0, (void* (*)(const void*, uint16))0 }
const tBlockFunctions blockFunctionTable[] = {
    FUNCTIONS,
    END_BLOCKFUNCTIONS
};

/* Parameter identifier table                                                                                         */
#define END_PARAMETERTABLE { (uint16)0, (void*)0 }
const tParameterTable parameterIdTable[] = {
    PARAMETER_TABLE,
    END_PARAMETERTABLE
};

/* Inport Parameter identifier table                                                                                  */
#define END_PARAMID_IO_TABLE { 0, 0, (void*)0 }
const tIoParamIdEntry inportParamIdTable[] = {
    INPORT_PARAMID_TABLE, 
    END_PARAMID_IO_TABLE
};

/* Outport Parameter identifier table                                                                                 */
const tIoParamIdEntry outportParamIdTable[] = {
    OUTPORT_PARAMID_TABLE, 
    END_PARAMID_IO_TABLE
};
/* Mask Parameter identifier table                                                                                    */
#define END_MASKPARAMID_TABLE { 0, (void*)0, (void*)0, (tSaveMaskParameter)0, (tLoadMaskParameter)0 }
static const tMaskParameterEntry maskParamIdTable[] = {
    END_MASKPARAMID_TABLE
};

/**********************************************************************************************************************/
/** Model Sample Time                                                                                                **/
/**********************************************************************************************************************/
float_CoT getModelSampleTime()
{
    return ((float_CoT)1.0E-4);
}

/**********************************************************************************************************************/
/**                                                  Initialization                                                  **/
/**********************************************************************************************************************/
void X2C_Init()
{
    /******************************************************************************************************************/
    /**                                          Initialize Block Parameters                                         **/
    /******************************************************************************************************************/

    /* Block: DigOut4                                                                                                 */
    /* Value = 0.0                                                                                                    */
    x2cModel.blocks.bDigOut4.K = 0;

    /* Block: AutoSwitch2                                                                                             */
    /* Thresh_up = 50.0                                                                                               */
    /* Thresh_down = 50.0                                                                                             */
    x2cModel.blocks.bAutoSwitch2.Thresh_up = 50;
    x2cModel.blocks.bAutoSwitch2.Thresh_down = 50;
    x2cModel.blocks.bAutoSwitch2.Status = 0;

    /* Block: AutoSwitch1                                                                                             */
    /* Thresh_up = 50.0                                                                                               */
    /* Thresh_down = 50.0                                                                                             */
    x2cModel.blocks.bAutoSwitch1.Thresh_up = 50;
    x2cModel.blocks.bAutoSwitch1.Thresh_down = 50;
    x2cModel.blocks.bAutoSwitch1.Status = 0;

    /* Block: DigOut2                                                                                                 */
    /* Value = 0.0                                                                                                    */
    x2cModel.blocks.bDigOut2.K = 0;

    /* Block: DigOut3                                                                                                 */
    /* Value = 0.0                                                                                                    */
    x2cModel.blocks.bDigOut3.K = 0;

    /* Block: AutoSwitch3                                                                                             */
    /* Thresh_up = 50.0                                                                                               */
    /* Thresh_down = 50.0                                                                                             */
    x2cModel.blocks.bAutoSwitch3.Thresh_up = 50;
    x2cModel.blocks.bAutoSwitch3.Thresh_down = 50;
    x2cModel.blocks.bAutoSwitch3.Status = 0;

    /* Block: LED_on_off                                                                                              */
    /* Value = 0.0                                                                                                    */
    x2cModel.blocks.bLED_on_off.K = 0;

    /* Block: Start_Stop                                                                                              */
    /* Value = 1.0                                                                                                    */
    x2cModel.blocks.bStart_Stop.K = 1;

    /* Block: Sin3Gen                                                                                                 */
    /* fmax = 1000.0                                                                                                  */
    /* Offset = 50.0                                                                                                  */
    /* ts_fact = 1.0                                                                                                  */
    x2cModel.blocks.bSin3Gen.delta_phi = .000628318530718;
    x2cModel.blocks.bSin3Gen.offset = 50;
    x2cModel.blocks.bSin3Gen.phi = 0;

    /* Block: Amplitude                                                                                               */
    /* Value = 50.0                                                                                                   */
    x2cModel.blocks.bAmplitude.K = 50;

    /* Block: TriangleGenerator/Negation                                                                              */

    /* Block: TriangleGenerator/LoopBreaker                                                                           */

    /* Block: TriangleGenerator/Init                                                                                  */
    /* Value = 0.0                                                                                                    */
    x2cModel.blocks.sTriangleGenerator.bInit.K = 0;

    /* Block: TriangleGenerator/AutoSwitch0                                                                           */
    /* Thresh_up = 500.0                                                                                              */
    /* Thresh_down = 0.0                                                                                              */
    x2cModel.blocks.sTriangleGenerator.bAutoSwitch0.Thresh_up = 500;
    x2cModel.blocks.sTriangleGenerator.bAutoSwitch0.Thresh_down = 0;
    x2cModel.blocks.sTriangleGenerator.bAutoSwitch0.Status = 0;

    /* Block: TriangleGenerator/Slope                                                                                 */
    /* Value = 10.0                                                                                                   */
    x2cModel.blocks.sTriangleGenerator.bSlope.K = 10;

    /* Block: TriangleGenerator/I                                                                                     */
    /* Ki = 1.0                                                                                                       */
    /* ts_fact = 1.0                                                                                                  */
    x2cModel.blocks.sTriangleGenerator.bI.b0 = .0001;
    x2cModel.blocks.sTriangleGenerator.bI.i_old = 0;
    x2cModel.blocks.sTriangleGenerator.bI.enable_old = 0;

    /* Block: LED off                                                                                                 */
    /* Value = 0.0                                                                                                    */
    x2cModel.blocks.bLED_off.K = 0;

    /* Block: LED on                                                                                                  */
    /* Value = 1.0                                                                                                    */
    x2cModel.blocks.bLED_on.K = 1;

    /* Block: DigOut1                                                                                                 */
    /* Value = 0.0                                                                                                    */
    x2cModel.blocks.bDigOut1.K = 0;


    /******************************************************************************************************************/
    /**                                               Link Block Inputs                                              **/
    /******************************************************************************************************************/

    /* Block DigOut4                                                                                                  */

    /* Block AutoSwitch2                                                                                              */
    x2cModel.blocks.bAutoSwitch2.In1 =
        &x2cModel.blocks.bLED_off.Out;
    x2cModel.blocks.bAutoSwitch2.Switch =
        &x2cModel.blocks.bSin3Gen.v;
    x2cModel.blocks.bAutoSwitch2.In3 =
        &x2cModel.blocks.bLED_on.Out;

    /* Block AutoSwitch1                                                                                              */
    x2cModel.blocks.bAutoSwitch1.In1 =
        &x2cModel.blocks.bLED_off.Out;
    x2cModel.blocks.bAutoSwitch1.Switch =
        &x2cModel.blocks.bSin3Gen.u;
    x2cModel.blocks.bAutoSwitch1.In3 =
        &x2cModel.blocks.bLED_on.Out;

    /* Block DigOut2                                                                                                  */

    /* Block DigOut3                                                                                                  */

    /* Block AutoSwitch3                                                                                              */
    x2cModel.blocks.bAutoSwitch3.In1 =
        &x2cModel.blocks.bLED_off.Out;
    x2cModel.blocks.bAutoSwitch3.Switch =
        &x2cModel.blocks.bSin3Gen.w;
    x2cModel.blocks.bAutoSwitch3.In3 =
        &x2cModel.blocks.bLED_on.Out;

    /* Block LED_on_off                                                                                               */

    /* Block Start_Stop                                                                                               */

    /* Block Sin3Gen                                                                                                  */
    x2cModel.blocks.bSin3Gen.A =
        &x2cModel.blocks.bAmplitude.Out;
    x2cModel.blocks.bSin3Gen.f =
        &x2cModel.blocks.sTriangleGenerator.bI.Out;

    /* Block Amplitude                                                                                                */

    /* Block Negation                                                                                                 */
    x2cModel.blocks.sTriangleGenerator.bNegation.In =
        &x2cModel.blocks.sTriangleGenerator.bSlope.Out;

    /* Block LoopBreaker                                                                                              */
    x2cModel.blocks.sTriangleGenerator.bLoopBreaker.In =
        &x2cModel.blocks.sTriangleGenerator.bI.Out;

    /* Block Init                                                                                                     */

    /* Block AutoSwitch0                                                                                              */
    x2cModel.blocks.sTriangleGenerator.bAutoSwitch0.In1 =
        &x2cModel.blocks.sTriangleGenerator.bNegation.Out;
    x2cModel.blocks.sTriangleGenerator.bAutoSwitch0.Switch =
        &x2cModel.blocks.sTriangleGenerator.bLoopBreaker.Out;
    x2cModel.blocks.sTriangleGenerator.bAutoSwitch0.In3 =
        &x2cModel.blocks.sTriangleGenerator.bSlope.Out;

    /* Block Slope                                                                                                    */

    /* Block I                                                                                                        */
    x2cModel.blocks.sTriangleGenerator.bI.In =
        &x2cModel.blocks.sTriangleGenerator.bAutoSwitch0.Out;
    x2cModel.blocks.sTriangleGenerator.bI.Init =
        &x2cModel.blocks.sTriangleGenerator.bInit.Out;
    x2cModel.blocks.sTriangleGenerator.bI.Enable =
        &x2cModel.blocks.bStart_Stop.Out;

    /* Block LEDoff                                                                                                   */

    /* Block LEDon                                                                                                    */

    /* Block DigOut1                                                                                                  */

    /******************************************************************************************************************/
    /**                                                 Link Outports                                                **/
    /******************************************************************************************************************/
    x2cModel.outports.bP9_21_22 =
        &x2cModel.blocks.bSin3Gen.u;
    x2cModel.outports.bP9_14_16 =
        &x2cModel.blocks.bSin3Gen.v;
    x2cModel.outports.bP8_13_19 =
        &x2cModel.blocks.bSin3Gen.w;
    x2cModel.outports.bP8_7 =
        &x2cModel.blocks.bDigOut1.Out;
    x2cModel.outports.bP8_11 =
        &x2cModel.blocks.bDigOut3.Out;
    x2cModel.outports.bP8_9 =
        &x2cModel.blocks.bDigOut2.Out;
    x2cModel.outports.bP8_15 =
        &x2cModel.blocks.bDigOut4.Out;
    x2cModel.outports.bLED1 =
        &x2cModel.blocks.bAutoSwitch1.Out;
    x2cModel.outports.bLED3 =
        &x2cModel.blocks.bAutoSwitch3.Out;
    x2cModel.outports.bLED0 =
        &x2cModel.blocks.bLED_on_off.Out;
    x2cModel.outports.bLED2 =
        &x2cModel.blocks.bAutoSwitch2.Out;

    /******************************************************************************************************************/
    /**                                           Run Block Init Functions                                           **/
    /******************************************************************************************************************/
    Constant_Bool_Init(&x2cModel.blocks.bDigOut4);
    AutoSwitch_Float32_Init(&x2cModel.blocks.bAutoSwitch2);
    AutoSwitch_Float32_Init(&x2cModel.blocks.bAutoSwitch1);
    Constant_Bool_Init(&x2cModel.blocks.bDigOut2);
    Constant_Bool_Init(&x2cModel.blocks.bDigOut3);
    AutoSwitch_Float32_Init(&x2cModel.blocks.bAutoSwitch3);
    Constant_Float32_Init(&x2cModel.blocks.bLED_on_off);
    Constant_Bool_Init(&x2cModel.blocks.bStart_Stop);
    Sin3Gen_Float32_Init(&x2cModel.blocks.bSin3Gen);
    Constant_Float32_Init(&x2cModel.blocks.bAmplitude);
    Negation_Float32_Init(&x2cModel.blocks.sTriangleGenerator.bNegation);
    LoopBreaker_Float32_Init(&x2cModel.blocks.sTriangleGenerator.bLoopBreaker);
    Constant_Float32_Init(&x2cModel.blocks.sTriangleGenerator.bInit);
    AutoSwitch_Float32_Init(&x2cModel.blocks.sTriangleGenerator.bAutoSwitch0);
    Constant_Float32_Init(&x2cModel.blocks.sTriangleGenerator.bSlope);
    I_Float32_Init(&x2cModel.blocks.sTriangleGenerator.bI);
    Constant_Float32_Init(&x2cModel.blocks.bLED_off);
    Constant_Float32_Init(&x2cModel.blocks.bLED_on);
    Constant_Bool_Init(&x2cModel.blocks.bDigOut1);
    Scope_Main_Init(&x2cScope);

    /* Initialize Mask parameter structures                                                                           */

    /* Initialize Implementation parameters of Conversion-on-Target blocks                                            */

    /* Initialize TableStruct tables                                                                                  */
    TableStruct->TFncTable = blockFunctionTable;
    TableStruct->TParamTable = parameterIdTable;
    TableStruct->inportParamTable = inportParamIdTable;
    TableStruct->outportParamTable = outportParamIdTable;
    TableStruct->maskParameterTable = maskParamIdTable;
}

/**********************************************************************************************************************/
/**                                            Run Block Update Functions                                            **/
/**********************************************************************************************************************/
void X2C_Update(void)
{
    X2C_Update_1();

}

/* X2C_Update for blocks with 1*Ts                                                                                    */
void X2C_Update_1(void)
{
    LoopBreaker_Float32_Update(&x2cModel.blocks.sTriangleGenerator.bLoopBreaker);
    Negation_Float32_Update(&x2cModel.blocks.sTriangleGenerator.bNegation);
    AutoSwitch_Float32_Update(&x2cModel.blocks.sTriangleGenerator.bAutoSwitch0);
    I_Float32_Update(&x2cModel.blocks.sTriangleGenerator.bI);
    Sin3Gen_Float32_Update(&x2cModel.blocks.bSin3Gen);
    AutoSwitch_Float32_Update(&x2cModel.blocks.bAutoSwitch1);
    AutoSwitch_Float32_Update(&x2cModel.blocks.bAutoSwitch2);
    AutoSwitch_Float32_Update(&x2cModel.blocks.bAutoSwitch3);
    Scope_Main_Update(&x2cScope);
}

